VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "comdlg32.ocx"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "comctl32.ocx"
Begin VB.Form frmFileComm 
   Caption         =   "File Communications Client"
   ClientHeight    =   2670
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9210
   LinkTopic       =   "Form1"
   ScaleHeight     =   2670
   ScaleWidth      =   9210
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnSetOutput 
      Caption         =   "Set Output"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   7860
      TabIndex        =   5
      Top             =   1920
      Width           =   1335
   End
   Begin VB.CommandButton btnSetInput 
      Caption         =   "Set Input"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   7860
      TabIndex        =   4
      Top             =   1500
      Width           =   1335
   End
   Begin ComctlLib.StatusBar sbrStatus 
      Align           =   2  'Align Bottom
      Height          =   315
      Left            =   0
      TabIndex        =   3
      Top             =   2355
      Width           =   9210
      _ExtentX        =   16245
      _ExtentY        =   556
      Style           =   1
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   1
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.TextBox txtIn 
      Height          =   1875
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Top             =   420
      Width           =   7755
   End
   Begin VB.Timer tmrFileComm 
      Left            =   8400
      Top             =   540
   End
   Begin MSComDlg.CommonDialog cdlFile 
      Left            =   7860
      Top             =   540
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327681
      CancelError     =   -1  'True
   End
   Begin VB.CommandButton btnSend 
      Caption         =   "Send"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   7860
      TabIndex        =   1
      Top             =   60
      Width           =   1335
   End
   Begin VB.TextBox txtOut 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   60
      Width           =   7755
   End
End
Attribute VB_Name = "frmFileComm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Instance of file communications class
Private mFileComm As New clsFileComm

' Buffer to hold data received on input channel
Private mStrInputBuffer As String

Private Sub Form_Load()
    ' Init timer parameters
    tmrFileComm.Interval = 2000
    tmrFileComm.Enabled = True
End Sub

Private Sub btnSetInput_Click()
    ' Set the input file.
    On Error GoTo btnSetInput_ClickErrorHandler
    
    With cdlFile
        .filename = mFileComm.InFile
        .DialogTitle = "Please enter the input file for communications"
        .Filter = "All Files (*.*)|*.*"
        .ShowOpen
        mFileComm.InFile = .filename
    End With
    
    Exit Sub
'______________________
btnSetInput_ClickErrorHandler:
    Select Case Err.Number
    Case cdlCancel
        ' Do nothing if cancelled
    Case Else
        MsgBox "Error (frmFileComm - btnSetInput) " & CStr(Err.Number) & ": " & Err.Description
    End Select
End Sub

Private Sub btnSetOutput_Click()
    ' Set the output file.
    On Error GoTo btnSetOutput_ClickErrorHandler
    
    With cdlFile
        .filename = mFileComm.OutFile
        .DialogTitle = "Please enter the output file for communications"
        .Filter = "All Files (*.*)|*.*"
        .ShowOpen
        mFileComm.OutFile = .filename
    End With
    
    Exit Sub
'______________________
btnSetOutput_ClickErrorHandler:
    Select Case Err.Number
    Case cdlCancel
        ' Do nothing if cancelled
    Case Else
        MsgBox "Error (frmFileComm - btnSetOutput) " & CStr(Err.Number) & ": " & Err.Description
    End Select
End Sub

Private Sub btnSend_Click()
    ' Send data to the output file.
    sbrStatus.SimpleText = "Sending to " & mFileComm.OutFile & " ..."
    mFileComm.SendData txtOut.Text
    sbrStatus.SimpleText = ""
End Sub

Private Sub tmrFileComm_Timer()
    ' Check input file at predetermined time intervals.
    ProcessInputBuffer
End Sub

Private Sub ProcessInputBuffer()
    Dim strMessage As String
    
    ' Get any new data
    If FetchInputData() = False Then Exit Sub
    
    ' Process all complete messages.
    strMessage = GetMessage()
    Do While strMessage <> ""
        ProcessMessage strMessage
        strMessage = GetMessage()
    Loop
        
End Sub

Private Function GetMessage() As String
    ' Get an entire message.
    Dim intPosition As Integer              ' Position of the line termination character(s)
    Dim strMessage As String                ' Store a message
                                            ' Error handler
    On Error GoTo GetMessageErrorHandler
    
    strMessage = ""                         ' Look for line termination characters
    intPosition = InStr(mStrInputBuffer, vbCr)
    If intPosition > 0 Then                 ' If found then remove the command
        strMessage = Left$(mStrInputBuffer, intPosition - 1)
                                            ' Keep any remaining data
        mStrInputBuffer = Right$(mStrInputBuffer, Len(mStrInputBuffer) - intPosition)
    End If
    
    GetMessage = strMessage                 ' Return message
    Exit Function
'______________________________
GetMessageErrorHandler:
    Select Case Err.Number
    Case Else
        MsgBox "Error (GetMessage) " & CStr(Err.Number) & ": " & Err.Description
    End Select
End Function

Private Function FetchInputData() As Boolean
    ' Get any new data from the input port and append to Input Queue.
    ' Return true if any found.
    Dim strData As String
    
    FetchInputData = False                  ' Assume no new data.
    
    mFileComm.GetData strData
    If strData <> "" Then
        mStrInputBuffer = mStrInputBuffer & strData
        FetchInputData = True
    End If

End Function

Private Sub ProcessMessage(strMessage As String)
    ' Process received message by appending to TextBox
    If strMessage <> "" Then txtIn.Text = txtIn.Text & strMessage & vbCrLf
End Sub

