VERSION 5.00
Object = "{02B5E320-7292-11CF-93D5-0020AF99504A}#1.0#0"; "MSCHART.OCX"
Begin VB.Form frmBrowser 
   Caption         =   "Microplate Data Browser"
   ClientHeight    =   7515
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9225
   LinkTopic       =   "Form1"
   ScaleHeight     =   7515
   ScaleWidth      =   9225
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnNewData 
      Caption         =   "New Data"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   7920
      TabIndex        =   5
      Top             =   7080
      Width           =   1275
   End
   Begin VB.TextBox txtDataValue 
      Height          =   315
      Left            =   3300
      TabIndex        =   4
      Top             =   7080
      Width           =   975
   End
   Begin VB.TextBox txtWell 
      Height          =   315
      Left            =   1140
      TabIndex        =   3
      Top             =   7080
      Width           =   975
   End
   Begin MSChartLib.MSChart chtPlate 
      Height          =   6855
      Left            =   60
      OleObjectBlob   =   "PlateBrowser.frx":0000
      TabIndex        =   0
      Top             =   120
      Width           =   9075
   End
   Begin VB.Label lblValue 
      Alignment       =   1  'Right Justify
      Caption         =   "Value:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   2340
      TabIndex        =   2
      Top             =   7080
      Width           =   915
   End
   Begin VB.Label lblWell 
      Alignment       =   1  'Right Justify
      Caption         =   "Well:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   300
      TabIndex        =   1
      Top             =   7080
      Width           =   795
   End
End
Attribute VB_Name = "frmBrowser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' A module level variant array to hold data and labels
Private mVrnData(0 To 8, 0 To 12) As Variant

Private Sub Form_Load()
    ' Set up the chart properties
    Dim I As Integer
    
    ' Set data point and data series labels
    For I = 1 To 8
        mVrnData(I, 0) = Chr$(I + 64)
    Next I
    For I = 1 To 12          ' Add a space to make the MSChart interpret the number as a label
        mVrnData(0, I) = " " & CStr(I)
    Next I
    
    ' Set up the chart
    With chtPlate
        ' Set chart type
        .chartType = VtChChartType3dBar
        
        ' Set axis label formats
        .Plot.Axis(VtChAxisIdX).Labels(1).VtFont.Size = 14
        .Plot.Axis(VtChAxisIdX).Labels(1).VtFont.Style = VtFontStyleBold
        .Plot.Axis(VtChAxisIdY).Labels(1).VtFont.Size = 14
        .Plot.Axis(VtChAxisIdY).Labels(1).VtFont.Style = VtFontStyleBold
        .Plot.Axis(VtChAxisIdZ).Labels(1).VtFont.Size = 14
        .Plot.Axis(VtChAxisIdZ).Labels(1).VtFont.Style = VtFontStyleBold
        
        ' Enable chart components to be selected
        .AllowSelections = True
        
        ' Disable series selection so that point selection occurs on first click
        .AllowSeriesSelection = False
        
        ' Allow the chart to be rotated by holding down the CTRL key to display the rotation cursor
        .AllowDynamicRotation = True
    
    End With
        
    ' Initially fill with random data
    btnNewData_Click
End Sub

Private Sub chtPlate_PointSelected(Series As Integer, DataPoint As Integer, MouseFlags As Integer, Cancel As Integer)
    ' Set the text box values
    txtWell.Text = Chr$(DataPoint + 64) & CStr(Series)
    txtDataValue.Text = Format(mVrnData(DataPoint, Series), "0.###")
End Sub

Private Sub btnNewData_Click()
    ' Regenerate random data and chart
    Dim I As Integer, J As Integer
    Static intPlateNum As Integer
    
    ' Generate data so only a few numbers are much greater than 0
    For I = 1 To 8
        For J = 1 To 12
            mVrnData(I, J) = Rnd ^ 20
        Next J
    Next I
    
    ' Assign data to the chart
    chtPlate.ChartData = mVrnData
    
    ' Create a new title
    intPlateNum = intPlateNum + 1
    chtPlate.TitleText = "Plate " & CStr(intPlateNum)
    chtPlate.Title.VtFont.Size = 20
End Sub

